# główna funkcja
def sol(w, k, tab):
    maxpoint = []
    temp = []
    # przygotowujemy potrzebne tablice
    for i in range(w):
        temp = []
        for j in range(k):
            temp.append(0)
        maxpoint.append(temp)

    # używamy "programowania dynamicznego", czyli dzielimy zadanie na prostsze podzadania.
    # dla każdego wiersza obliczamy ile najwięcej można zdobyć punktów, aby wylądować w danej kolumnie. Zapisujemy to w tablicy maxpoint.
    # na tego podstawie obliczamy tak dla kolejnych wierszy aż do samego końca
    # w pierwszym wersie maksymalna wartość dla danej kolumny to wartość tego pola
    for i in range(k):
        maxpoint[0][i] = tab[0][i]
    for i in range(1, w):
        for j in range(k):
            maksio = max(maxpoint[i - 1][j - 1], maxpoint[i - 1][j])
            if(j + 1 == k):
                maksio = max(maksio, maxpoint[i - 1][0])
            else:
                maksio = max(maksio, maxpoint[i - 1][j + 1])
            maxpoint[i][j] = maksio + tab[i][j]
    # zwracamy maksymalną wartość z maxpoint z ostatniej kolumny
    return max(maxpoint[w - 1])

# po rozpoczęciu programu wczytujemy wejście i przygotowujemy je w specjalny sposób w tablicach, aby programowi było łatwiej.
w, k = input().split(" ")
w = int(w)
k = int(k)
tab = []
temptab = []
for i in range(w):
    temptab = input().split(" ")
    for j in range(k):
        temptab[j] = int(temptab[j])
    tab.append(temptab)

tab.reverse()

print(sol(w, k, tab))
